/**
 * Created on 2008-06-12 12:18:17
 */
package org.put.semintec.mining.association;

import org.put.semintec.core.KnowledgeBase;
import org.semanticweb.kaon2.api.KAON2Exception;
import org.semanticweb.kaon2.api.reasoner.Query;

/**
 * Represents relational association rule (query extension).
 * @author Agnieszka Lawrynowicz
 * 
 */
public class AssociationRule {

	/**
	 * Antecedent of the rule
	 */
	private Pattern antecedent;
	 
	/**
	 * Getter of the property <tt>antecedent</tt>
	 *
	 * @return Returns the antecedent.
	 * 
	 */
	public Pattern getAntecedent()
	{
		return antecedent;
	}

	/**
	 * Setter of the property <tt>antecedent</tt>
	 *
	 * @param antecedent The antecedent to set.
	 *
	 */
	public void setAntecedent(Pattern antecedent){
		this.antecedent = antecedent;
	}
	
	/**
	 * Consequent of the rule
	 */
	private Pattern consequent;
	 
	/**
	 * Getter of the property <tt>consequent</tt>
	 *
	 * @return Returns the consequent.
	 * 
	 */
	public Pattern getConsequent()
	{
		return consequent;
	}

	/**
	 * Setter of the property <tt>consequent</tt>
	 *
	 * @param consequent The consequent to set.
	 *
	 */
	public void setConsequent(Pattern consequent){
		this.consequent = consequent;
	}

	/**
	 * Confidence of the rule
	 */
	private double confidence;
	 
	/**
	 * Getter of the property <tt>confidence</tt>
	 *
	 * @return Returns the confidence.
	 * 
	 */
	public double getConfidence()
	{
		return confidence;
	}

	/**
	 * Setter of the property <tt>confidence</tt>
	 *
	 * @param confidence The confidence to set.
	 *
	 */
	public void setConfidence(double confidence){
		this.confidence = confidence;
	}
	
	/**
	 * Calculates confidence of the rule
	 * 
	*/
	public void calculateConfidence() { 
		setConfidence((double) ((double)consequent.getSupport())/(double)(antecedent.getSupport()));
	}
}
