package org.put.semintec.utils;
/* Copyright (c) 2008 the authors listed at the following URL, and/or
the authors of referenced articles or incorporated external code:
http://en.literateprograms.org/Permutations_with_repetition_(Java)?action=history&offset=20080109002711

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Retrieved from: http://en.literateprograms.org/Permutations_with_repetition_(Java)?oldid=11971
*/

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import org.semanticweb.kaon2.api.KAON2Manager;
import org.semanticweb.kaon2.api.logic.Variable;

public class PermutationsWithRepetition {
	private String a;
	private int n;
	
	private Variable[] v;
	
	public PermutationsWithRepetition(String a, int n) {
		this.a = a;
		this.n = n;
	}

	public PermutationsWithRepetition(Variable[] v, int n) {
		this.v = v;
		this.n = n;
	}

	
	public List<String> getVariations() {
		int l = a.length();
		int permutations = (int) Math.pow(l, n);
		char[][] table = new char[permutations][n];
		
		for (int x = 0; x < n; x++) {
		    int t2 = (int) Math.pow(l, x);
		    for (int p1 = 0; p1 < permutations;) {
		        for (int al = 0; al < l; al++) {
		            for (int p2 = 0; p2 < t2; p2++) {
		                table[p1][x] = a.charAt(al);
		                p1++;
		            }
		        }
		    }
		}

		
		List<String> result = new ArrayList<String>();
		for (char[] permutation : table) {
		    result.add(new String(permutation));
		}
		return result;

	}

	public List<Variable[]> getVariableVariations() {
		int l = v.length;
		int permutations = (int) Math.pow(l, n);
		Variable[][] table = new Variable[permutations][n];
		
		for (int x = 0; x < n; x++) {
		    int t2 = (int) Math.pow(l, x);
		    for (int p1 = 0; p1 < permutations;) {
		        for (int j = 0; j < l; j++) {
		            for (int p2 = 0; p2 < t2; p2++) {
		                table[p1][x] = (Variable)v[j];
		                p1++;
		            }
		        }
		    }
		}

		
		List<Variable[]> result = new ArrayList<Variable[]>();
		for (Variable[] permutation : table) {
		    result.add(permutation);
		}
		return result;

	}

	
	public static void main(String[] args) {
		Variable  vs[] = new Variable[3];
		vs[0]=KAON2Manager.factory().variable("x");
		vs[1]=KAON2Manager.factory().variable("y");	
		vs[2]=KAON2Manager.factory().variable("z");

		PermutationsWithRepetition gen = new PermutationsWithRepetition(vs, 3);
		List<Variable[]> vk = gen.getVariableVariations();
		for (Iterator j=vk.iterator(); j.hasNext();)
		{
			Variable[] vr = (Variable[]) j.next(); 
			System.out.println(vr[0].toString()+vr[1].toString()+vr[2].toString());
		}

	}
}

