/**
 * Created on 2008-04-11 12:23:46
 */
package org.put.semintec.utils;

import java.util.Date;

/**
 * Stores statistics for pattern mining execution 
 * @author Agnieszka Lawrynowicz
 * 
 */
public class Statistics {


	public static final int PATTERN = 0;
	public static final int ASSOCIATION = 1;
	public static final int CLUSTERING = 2;
	
	/**
	   * Type of the data mining task  
	   */
		int miningTask; 

		/**
		 * Getter of the property <tt>miningTask</tt>
		 *
		 * @return Returns the miningTask.
		 * 
		 */
		public int getMiningTask() {
	    	return miningTask;
	    }

		/**
		 * Setter of the property <tt>miningTask</tt>
		 *
		 * @param miningTask The miningTask to set.
		 *
		 */
	    public void setMiningTask(int miningTask) {
	    	this.miningTask=miningTask;
	    }

	
/**
   * Start date and time of data mining execution.
   */
	Date startDate; 

	/**
	 * Getter of the property <tt>startDate</tt>
	 *
	 * @return Returns the startDate.
	 * 
	 */
	public Date getStartDate() {
    	return startDate;
    }

	/**
	 * Setter of the property <tt>startDate</tt>
	 *
	 * @param startDate The startDate to set.
	 *
	 */
    public void setStartDate(Date startDate) {
    	this.startDate=startDate;
    }

    /**
     * Stop date and time of pattern mining execution.
     */
    Date stopDate;
    
	/**
	 * Getter of the property <tt>stopDate</tt>
	 *
	 * @return Returns the stopDate.
	 * 
	 */
    public Date getStopDate() {
    	return stopDate;
    }

	/**
	 * Setter of the property <tt>stopDate</tt>
	 *
	 * @param stopDate The stopDate to set.
	 *
	 */
    public void setStopDate(Date stopDate) {
    	this.stopDate=stopDate;
    }

    /**
     * Number of candidates with length equal or less MAX_LENGTH
     */
    int numCandidatesUpToMaxLength;
    

	/**
	 * Setter of the property <tt>numCandidatesUpToMaxLength</tt>
	 *
	 * @param numCandidatesUpToMaxLength The numCandidatesUpToMaxLength to set.
	 *
	 */
    public void setNumCandidatesUpToMaxLength(int numCandidatesUpToMaxLength) {
    	this.numCandidatesUpToMaxLength=numCandidatesUpToMaxLength;
    }

	/**
	 * Getter of the property <tt>numCandidatesUpToMaxLength</tt>
	 *
	 * @return Returns the numCandidatesUpToMaxLength.
	 * 
	 */
    public int getNumCandidatesUpToMaxLength() {
    	return numCandidatesUpToMaxLength;
    }
    
    /**
     * Number of candidates with length equal MAX_LENGTH
     */
    int numCandidatesWithMaxLength;

	/**
	 * Setter of the property <tt>numCandidatesWithMaxLength</tt>
	 *
	 * @param numCandidatesWithMaxLength The numCandidatesWithMaxLength to set.
	 *
	 */
    public void setNumCandidatesWithMaxLength(int numCandidatesWithMaxLength) {
    	this.numCandidatesWithMaxLength=numCandidatesWithMaxLength;
    }
    
	/**
	 * Getter of the property <tt>numCandidatesWithMaxLength</tt>
	 *
	 * @return Returns the numCandidatesWithMaxLength.
	 * 
	 */
    public int getNumCandidatesWithMaxLength() {
    	return numCandidatesWithMaxLength;
    }


    /**
     * Number of patterns with length equal or less MAX_LENGTH
     */
    int numPatternsUpToMaxLength;

	/**
	 * Setter of the property <tt>numPatternsUpToMaxLength</tt>
	 *
	 * @param numPatternsUpToMaxLength The numPatternsUpToMaxLength to set.
	 *
	 */
    public void setNumPatternsUpToMaxLength(int numPatternsUpToMaxLength) {
    	this.numPatternsUpToMaxLength=numPatternsUpToMaxLength;
    }
    
	/**
	 * Getter of the property <tt>numPatternsUpToMaxLength</tt>
	 *
	 * @return Returns the numPatternsUpToMaxLength.
	 * 
	 */
    public int getNumPatternsUpToMaxLength() {
    	return numPatternsUpToMaxLength;
    }
    
    /**
     * Number of patterns with length equal MAX_LENGTH
     */
    int numPatternsWithMaxLength;

	/**
	 * Setter of the property <tt>numPatternsWithMaxLength</tt>
	 *
	 * @param numPatternsWithMaxLength The numPatternsWithMaxLength to set.
	 *
	 */
    public void setNumPatternsWithMaxLength(int numPatternsWithMaxLength) {
    	this.numPatternsWithMaxLength=numPatternsWithMaxLength;
    }
    
	/**
	 * Getter of the property <tt>numPatternsWithMaxLength</tt>
	 *
	 * @return Returns the numPatternsWithMaxLength.
	 * 
	 */
    public int getNumPatternsWithMaxLength() {
    	return numPatternsWithMaxLength;
    }

    /**
     * Number of generated, by refinement rules, patterns with length equal or less MAX_LENGTH
     */
    int numGENUpToMaxLength;
    

	/**
	 * Setter of the property <tt>numGENUpToMaxLength</tt>
	 *
	 * @param numGENUpToMaxLength The numGENUpToMaxLength to set.
	 *
	 */
    public void setNumGENUpToMaxLength(int numGENUpToMaxLength) {
    	this.numGENUpToMaxLength=numGENUpToMaxLength;
    }

	/**
	 * Getter of the property <tt>numGENUpToMaxLength</tt>
	 *
	 * @return Returns the numGENUpToMaxLength.
	 * 
	 */
    public int getNumGENUpToMaxLength() {
    	return numGENUpToMaxLength;
    }


    /**
     * Number of generated, by refinement rules, patterns with length equal MAX_LENGTH
     */
    int numGENWithMaxLength;
    

	/**
	 * Setter of the property <tt>numGENWithMaxLength</tt>
	 *
	 * @param numGENWithMaxLength The numGENWithMaxLength to set.
	 *
	 */
    public void setNumGENWithMaxLength(int numGENWithMaxLength) {
    	this.numGENWithMaxLength=numGENWithMaxLength;
    }

	/**
	 * Getter of the property <tt>numGENWithMaxLength</tt>
	 *
	 * @return Returns the numGENWithMaxLength.
	 * 
	 */
    public int getNumGENWithMaxLength() {
    	return numGENWithMaxLength;
    }
    
    /**
     * Number of generated satisfiable patterns with length equal or less MAX_LENGTH
     */
    int numSATUpToMaxLength;
    

	/**
	 * Setter of the property <tt>numSATUpToMaxLength</tt>
	 *
	 * @param numSATUpToMaxLength The numSATUpToMaxLength to set.
	 *
	 */
    public void setNumSATUpToMaxLength(int numSATUpToMaxLength) {
    	this.numSATUpToMaxLength=numSATUpToMaxLength;
    }

	/**
	 * Getter of the property <tt>numSATUpToMaxLength</tt>
	 *
	 * @return Returns the numSATUpToMaxLength.
	 * 
	 */
    public int getNumSATUpToMaxLength() {
    	return numSATUpToMaxLength;
    }


    /**
     * Number of generated satisfiable patterns with length equal MAX_LENGTH
     */
    int numSATWithMaxLength;
    

	/**
	 * Setter of the property <tt>numSATWithMaxLength</tt>
	 *
	 * @param numSATWithMaxLength The numSATWithMaxLength to set.
	 *
	 */
    public void setNumSATWithMaxLength(int numSATWithMaxLength) {
    	this.numSATWithMaxLength=numSATWithMaxLength;
    }

	/**
	 * Getter of the property <tt>numSATWithMaxLength</tt>
	 *
	 * @return Returns the numSATWithMaxLength.
	 * 
	 */
    public int getNumSATWithMaxLength() {
    	return numSATWithMaxLength;
    }

    /**
     * Number of generated sfree patterns with length equal or less MAX_LENGTH
     */
    int numSFREEUpToMaxLength;
    

	/**
	 * Setter of the property <tt>numSFREEUpToMaxLength</tt>
	 *
	 * @param numSFREEUpToMaxLength The numSFREEUpToMaxLength to set.
	 *
	 */
    public void setNumSFREEUpToMaxLength(int numSFREEUpToMaxLength) {
    	this.numSFREEUpToMaxLength=numSFREEUpToMaxLength;
    }

	/**
	 * Getter of the property <tt>numSFREEUpToMaxLength</tt>
	 *
	 * @return Returns the numSFREEUpToMaxLength.
	 * 
	 */
    public int getNumSFREEUpToMaxLength() {
    	return numSFREEUpToMaxLength;
    }


    /**
     * Number of generated sfree patterns with length equal MAX_LENGTH
     */
    int numSFREEWithMaxLength;
    

	/**
	 * Setter of the property <tt>numSFREEWithMaxLength</tt>
	 *
	 * @param numSFREEWithMaxLength The numSFREEWithMaxLength to set.
	 *
	 */
    public void setNumSFREEWithMaxLength(int numSFREEWithMaxLength) {
    	this.numSFREEWithMaxLength=numSFREEWithMaxLength;
    }

	/**
	 * Getter of the property <tt>numSFREEWithMaxLength</tt>
	 *
	 * @return Returns the numSFREEWithMaxLength.
	 * 
	 */
    public int getNumSFREEWithMaxLength() {
    	return numSFREEWithMaxLength;
    }

    
    /**
     * 
     * Starts collecting the statistics of pattern mining execution
     */
    public void startToCollect() {
    	//set start date	
    	setStartDate(new Date());
    	
    	//initialize candidate and pattern counters
    	 setNumCandidatesUpToMaxLength(0);
    	 setNumCandidatesWithMaxLength(0); 
    	 setNumPatternsUpToMaxLength(0); 
    	 setNumPatternsWithMaxLength(0);
    	 setNumSATUpToMaxLength(0); 
    	 setNumSATWithMaxLength(0);
    	 setNumSFREEUpToMaxLength(0); 
    	 setNumSFREEWithMaxLength(0);

    }

    /**
     * 
     * Stop collecting the statistics of pattern mining execution
     */
    public void stopToCollect() {
    	//set stop date
    	setStopDate(new Date());
    	
    	
    }
    
    /**
     * Calculates execution time of pattern mining
     * @return Time in milliseconds
     */
    public long calculateExecutionTime() {
    	return stopDate.getTime()-startDate.getTime();
    }

}
