/**
 * Created on 2008-03-18 12:01:55
 */
package org.put.semintec.core;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.put.semintec.mining.association.Bias;
import org.put.semintec.mining.association.Pattern;
import org.put.semintec.mining.association.PatternMiningWithoutBackgroundKnowledge;
import org.put.semintec.mining.datastructures.Node;
import org.put.semintec.mining.datastructures.Trie;
import org.put.semintec.utils.IOUtils;
import org.put.semintec.utils.Statistics;

import org.semanticweb.kaon2.api.DefaultOntologyResolver;
import org.semanticweb.kaon2.api.Entity;
import org.semanticweb.kaon2.api.KAON2Connection;
import org.semanticweb.kaon2.api.KAON2Exception;
import org.semanticweb.kaon2.api.KAON2Manager;
import org.semanticweb.kaon2.api.OntologyChangeEvent;
import org.semanticweb.kaon2.api.formatting.OntologyFileFormat;
import org.semanticweb.kaon2.api.logic.Formula;
import org.semanticweb.kaon2.api.logic.Literal;
import org.semanticweb.kaon2.api.logic.Predicate;
import org.semanticweb.kaon2.api.logic.PredicateSymbol;
import org.semanticweb.kaon2.api.logic.QueryDefinition;
import org.semanticweb.kaon2.api.logic.Rule;
import org.semanticweb.kaon2.api.logic.Term;
import org.semanticweb.kaon2.api.logic.Variable;
import org.semanticweb.kaon2.api.owl.elements.AnnotationProperty;
import org.semanticweb.kaon2.api.owl.elements.DataProperty;
import org.semanticweb.kaon2.api.owl.elements.Individual;
import org.semanticweb.kaon2.api.owl.elements.OWLClass;
import org.semanticweb.kaon2.api.owl.elements.ObjectProperty;
import org.semanticweb.kaon2.api.reasoner.Query;
import org.semanticweb.kaon2.api.Request;




/**
 * Represents an example application for executing mining algorithm without exploiting semantics of KB during pattern generation.
 * @author Agnieszka Lawrynowicz
 * 
 */
public class SemintecAppWithoutBackgroundKnowledge {

	/**
	 * @param args setupFileName
	 * @throws KAON2Exception 
	 * @throws InterruptedException 
	 * @throws IOException 
	 */
	public static void main(String[] args) throws KAON2Exception, InterruptedException, IOException {
        IOUtils ioUtils = new IOUtils();
        HashMap params = ioUtils.readXMLSetupFile(args[0]);
        
		KnowledgeBase kb = new KnowledgeBase();

		KAON2Connection connection=KAON2Manager.newConnection();
		DefaultOntologyResolver resolver=new DefaultOntologyResolver();

		resolver.registerReplacement((String)params.get("ontologyURI"), (String)params.get("physicalURI"));
        connection.setOntologyResolver(resolver);

        kb.setConnection(connection);
        kb.setResolver(resolver);
        kb.setOntology(connection.openOntology((String)params.get("ontologyURI"),new HashMap<String,Object>()));
        kb.setReasoner(kb.getOntology().createReasoner());

///------regula-----
 //       ObjectProperty isOwnerOf = KAON2Manager.factory().objectProperty("http://www.owl-ontologies.com/pkdd2007.owl#isOwnerOf");
//		OWLClass Account = KAON2Manager.factory().owlClass("http://www.owl-ontologies.com/pkdd2007.owl#Account");
//		ObjectProperty relative = KAON2Manager.factory().objectProperty("http://www.owl-ontologies.com/pkdd2007.owl#relative");
//		PredicateSymbol FamilyAccount = KAON2Manager.factory().predicateSymbol("http://www.owl-ontologies.com/pkdd2007.owl#FamilyAccount", 1);
		
//		Variable x1 = KAON2Manager.factory().variable("-1");
//		Variable x2 = KAON2Manager.factory().variable("x2");
//		Variable x3 = KAON2Manager.factory().variable("x3");
//		Variable x4 = KAON2Manager.factory().variable("x4");

//		Literal family_account_x1=KAON2Manager.factory().literal(true,FamilyAccount,new Term[] { x1 });
//		Literal account_x1=KAON2Manager.factory().literal(true,Account,new Term[] { x1 });
//		Literal lit2=KAON2Manager.factory().literal(true,isOwnerOf,new Term[] { x2, x1 });
//		Literal lit3=KAON2Manager.factory().literal(true,isOwnerOf,new Term[] { x3, x1 });
//		Literal lit4=KAON2Manager.factory().literal(true,relative,new Term[] { x2, x3 });

//		List<OntologyChangeEvent> changes=new ArrayList<OntologyChangeEvent>();
//		Rule r = KAON2Manager.factory().rule(
//				family_account_x1,                          // this is the rule head, i.e. the consequent of the rule
//				new Literal[] {account_x1, lit2, lit3, lit4 }   // this is the rule body, i.e. the condition of the rule
//		);
//		changes.add(new OntologyChangeEvent(r ,OntologyChangeEvent.ChangeType.ADD));
//		kb.getOntology().applyChanges(changes);
		
///--koniec regula        
		
		KnowledgeBase kbCopy = kb.copy(false);

		OWLClass refClass=KAON2Manager.factory().owlClass((String)params.get("refclass"));

		Bias bias = new Bias();
		
		if (((String)params.get("predicates")).compareTo("all") == 0) {
		
			Request<Entity> entityRequest = kb.getOntology().createEntityRequest();
			Set<Entity> entities = entityRequest.get();
			for (Entity entity : entities) {
//				System.out.println("encja:"+entity.toString());
//				if (entity instanceof OWLClass || entity instanceof ObjectProperty || entity instanceof PredicateSymbol)
				if (!(entity instanceof Individual) && !(entity instanceof DataProperty) &&
					!(entity instanceof AnnotationProperty))
				{
					Query q = kb.getReasoner().createQuery((Predicate)entity);
					q.open();
					if (!q.afterLast()) {
						bias.predicates.add(entity);	
					} 
					q.close();
					q.dispose();
				} 
			}
		} else {
			//TODO - parse predicates 
		}

		System.out.println("sss"+bias.predicates.size());
		
		
		Statistics statistics = new Statistics();
		statistics.setMiningTask(Statistics.PATTERN);
	
///testy		
//		OWLClass Client = KAON2Manager.factory().owlClass("http://www.owl-ontologies.com/pkdd2007.owl#Client");
//		Literal l1=KAON2Manager.factory().literal(true,Client,new Term[] { x1 });
//		Literal l2=KAON2Manager.factory().literal(true,isOwnerOf,new Term[] { x1, x2 });
//		Literal l3=KAON2Manager.factory().literal(true,isOwnerOf,new Term[] { x1, x3 });

//		ArrayList lits = new ArrayList();
//		lits.add(l1);
//		lits.add(l2);
		//lits.add(l3);
		
//		Formula conj = KAON2Manager.factory().conjunction(lits);
//		QueryDefinition qd = KAON2Manager.factory().queryDefinition(conj, new Variable[]{x1});
			
//		Pattern pp=new Pattern(qd);
//		System.out.println("isSFree:"+pp.isSFree(kbCopy));
//koniec testy/////
		
		PatternMiningWithoutBackgroundKnowledge pm = new PatternMiningWithoutBackgroundKnowledge();
        pm.setKb(kb);
        pm.setKbCopy(kbCopy);
        pm.setMinSupport(Double.valueOf((String)params.get("minsup")).doubleValue());
        pm.setMaxLength(Integer.valueOf((String)params.get("maxlength")).intValue());
        pm.setRefClass(refClass);
        pm.setBias(bias);
        pm.setStatistics(statistics);
        if (((String)params.get("answercaching")).compareTo("yes") == 0) {
        	pm.setAnswerCaching(true);
        } else {
        	pm.setAnswerCaching(false);
        }
        pm.getStatistics().startToCollect();
        pm.mine();
        pm.getStatistics().stopToCollect();
        
        ioUtils.saveToGraphML(pm.getTrie(), (String)params.get("patternsFileName")+".graphml", new String[1]);
        ioUtils.saveStatistics(params, statistics, (String)params.get("statisticsFileName"));
        ioUtils.savePatterns(params, pm.getTrie(), (String)params.get("patternsFileName"));

        //TODO - trie dispose
        //TODO - infrequent patterns dispose --- chodzi o query

        kb.getReasoner().dispose();
        kbCopy.getReasoner().dispose();
        connection.close();
	}

}

